package com.ibm.sample.hpel;

import java.util.Date;
import java.util.logging.Level;

import com.ibm.websphere.logging.hpel.reader.LogQueryBean;
import com.ibm.websphere.logging.hpel.reader.LogRepositoryException;
import com.ibm.websphere.logging.hpel.reader.LogRepositoryRuntimeException;
import com.ibm.websphere.logging.hpel.reader.RepositoryLogRecord;
import com.ibm.websphere.logging.hpel.reader.RepositoryReader;
import com.ibm.websphere.logging.hpel.reader.RepositoryReaderImpl;
import com.ibm.websphere.logging.hpel.reader.ServerInstanceLogRecordList;

/**
 * simple sample of using the Read API.  To make this run requires only the com.ibm.hpel.logging.jar in the buildpath
 * and runtime classpath. In practice, more information will be printed for each record and special formatting will be done,
 * this is primarily a sample to enable someone to begin using the technology with a simple self-contained program.  It goes
 * through all ServerInstances in a repository.  It does not handle a z/OS condition of child processes.  See other samples
 * for that.
 */
public class LocalReaderSampleFiltered {

	public static void main(String[] args) {
				// Create a repository reader (requires base directory of repository 
		RepositoryReader logRepository = new RepositoryReaderImpl(args[0]) ;		
				// Get iterator of server instances (start/stop of the server) extracting all log messages with
				// severity between INFO and SEVERE.  Lots of different filtering options, this is just one sample
		ServerInstanceLogRecordList pidRecords = null;
		LogQueryBean logQueryBean = new LogQueryBean() ;
		logQueryBean.setIncludeLoggers(new String [] { "*myapp*" }) ;
		logQueryBean.setLevels(Level.WARNING, Level.SEVERE) ;
		try {
			pidRecords = logRepository.getLogListForServerInstance((Date)null, logQueryBean) ;
		} catch (LogRepositoryException e) {
			System.out.println("Exception reading local repository: "+e);
		}
		try {
			for (RepositoryLogRecord repositoryLogRecord : pidRecords) {
					// Just printing some key information here.  Note that the repositoryRecord exposes all fields
					// with simple get methods
					System.out.println("  "+repositoryLogRecord.getFormattedMessage());
			}
		} catch (LogRepositoryRuntimeException lrre) {
			System.out.println("Exception while retrieving data: "+lrre);
		}
	}
}