package com.ibm.sample.hpel;

import java.util.Iterator;
import java.util.Map;

import com.ibm.websphere.logging.hpel.reader.LogRepositoryException;
import com.ibm.websphere.logging.hpel.reader.LogRepositoryRuntimeException;
import com.ibm.websphere.logging.hpel.reader.RepositoryReader;
import com.ibm.websphere.logging.hpel.reader.RepositoryReaderImpl;
import com.ibm.websphere.logging.hpel.reader.ServerInstanceLogRecordList;

/**
 * simple sample of using the Read API.  To make this run requires only the com.ibm.hpel.logging.jar in the buildpath
 * and runtime classpath
 */
public class LocalReaderSampleZos {

	public static void main(String[] args) {
		SampleHelper writeHandler = new SampleHelper("/tmp/LocalReaderSampleZos.log", false) ;
				// Create a repository reader (requires base directory of repository 
		RepositoryReader logRepository = new RepositoryReaderImpl(args[0]) ;		
				// Get iterator of server instances (start/stop of the server) extracting all log messages with
				// severity between INFO and SEVERE.  Lots of different filtering options, this is just one sample
		
		ServerInstanceLogRecordList silrl = null;
		try {
			silrl = logRepository.getLogListForCurrentServerInstance();
		} catch (LogRepositoryException e) {
			System.out.println("Exception getting log list: "+e);
			e.printStackTrace();
			System.exit(-99) ;
		}
		writeHandler.reportSILRL(silrl, "Controller") ;		// Use this to format the header and log records
				// Now find out if this process had child processes (used only for z/OS controller (parent) and servants (children)
    	Map<String, ServerInstanceLogRecordList>servantMap = silrl.getChildren() ;
        Iterator<String> servantKeys = servantMap.keySet().iterator() ;
        try {
	        while (servantKeys.hasNext()) {
	        	String label = servantKeys.next() ;			// Map label has key information to identify which child process
	        	ServerInstanceLogRecordList servantRecs = servantMap.get(label) ;		// Pull the child process serverInstance
	        	writeHandler.reportSILRL(servantRecs, label) ;							// Format the serverInstance
	        }
		} catch (LogRepositoryRuntimeException lrre) {
			System.out.println("Exception while retrieving data: "+lrre);
		}
        writeHandler.close() ;
	}
}